<template>
    <client-only>
        <cdx-dialog
            v-model:open="open"
            :title="dialogTitle"
            close-button-label="Close"
            :primary-action="primaryAction"
            :default-action="defaultAction"
            @primary="onPrimaryAction"
            @default="onDefaultAction"
      @update:open="onDefaultAction"
      data-id="dialog-delete"
        >
      <p>{{ dialogText }}</p>
      <br />
      <p>{{ dialogTextAddendum }}</p>
        </cdx-dialog>
    </client-only>
</template>

<script setup>
import { ref } from 'vue'
import { CdxDialog } from '@wikimedia/codex'
import { toast } from 'vue3-toastify';
import 'vue3-toastify/dist/index.css';
import { useCookies} from 'vue3-cookies';
import { useInstrumentStore } from '../../stores/instrument.js'

const { cookies } = useCookies();
const store = useInstrumentStore();

const open = ref( true )

const emit = defineEmits(["dialog-event"]);
const closeDialog = () => emit("dialog-event");

const type = store.instrument.type;
const dialogTitle = `Are you sure you want to delete this ${type} configuration?`;
const dialogText = `This will permanently delete the ${type} "${store.instrument.name}" and stop data collection. You cannot undo this action.`;
const dialogTextAddendum = `If you wish to fully decomision this instrument, the instrumentation code must be removed separately.`;

const primaryAction = {
  label: 'Delete',
  actionType: 'destructive'
};

const defaultAction = {
  label: 'Cancel'
};

function onDefaultAction() {
  open.value = false
  closeDialog()
}

async function onPrimaryAction() {
  open.value = false

  const data = Object.assign({
      csrf_token: cookies.get('csrf_token'),
  }, store.instrument);    

  const response = await store.deleteInstrument(data);
  toast(response.data.title, {
      type: response.success ? 'success' : 'error',
      position: 'bottom-right',
      autoClose: 100,
      pauseOnFocusLoss: false,
      hideProgressBar: true,
      ...response.success && { onClose: () => location.reload() }
  });

  // In case of error the dialog will be closed manually to be able to show it again
  if (!response.success) {
    closeDialog()
  }
}
</script>
